#!/usr/bin/env node
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const cosmiconfig_1 = require("cosmiconfig");
const cosmiconfig_typescript_loader_1 = require("@endemolshinegroup/cosmiconfig-typescript-loader");
// find config
const explorer = cosmiconfig_1.cosmiconfig("typedraft", {
    searchPlaces: [`typedraft.config.ts`],
    loaders: {
        ".ts": cosmiconfig_typescript_loader_1.default,
    },
});
function withConfig(callback) {
    explorer.search().then(configInfo => {
        let config = { DSLs: [], DraftPlugins: [], Targets: [] };
        if (configInfo && !configInfo.isEmpty) {
            config = Object.assign(Object.assign({}, config), configInfo.config);
        }
        callback(config);
    });
}
exports.withConfig = withConfig;
