"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class DSLPlugin {
    constructor(transcriber) {
        this.m_Transcriber = transcriber;
    }
    Transcribe() {
        const ResolveDSL = (context) => {
            const dsl = this.m_Transcriber.GetDSL(context.GetDSLName());
            if (dsl) {
                context.Resolve(dsl);
            }
        };
        this.m_Transcriber.TraverseInlineContext(ResolveDSL);
        this.m_Transcriber.TraverseLocalContext(ResolveDSL);
    }
}
exports.DSLPlugin = DSLPlugin;
